<template>
  <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button
      type="primary"
      circle
      v-show="!editable"
      @click="editable = !editable"
      >编辑</el-button
    >
    <el-button type="primary" v-show="editable" @click="saveData"
      >确定</el-button
    >
  </div>
  <div id="printContent" ref="imageWrapper">
    <h3>翻边、滚筋/封口工序生产质量记录</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime1 }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>

      <!-- <div class="title_form_input">
            <span>生产线：</span>
            <span>四线</span>
          </div> -->
    </div>
    <el-divider />

    <HJTABLE
      :SClist="SClist"
      :tableHeader="tableHeader"
      :labelName="labelName.b1"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="ytfpData"
      :tableHeader="ytfpHeader"
      :labelName="labelName.b2"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="fbfpData"
      :tableHeader="fbfpHeader"
      :labelName="labelName.b3"
      :editable="editable"
    ></HJTABLE>

    <div>
      <el-row>
        <el-col :span="8">
          <HJTABLE
            :SClist="zlList"
            :tableHeader="zlHeader"
            :labelName="labelName.b4"
            :editable="editable"
          ></HJTABLE>
        </el-col>
        <el-col :span="8">
          <HJTABLE
            :SClist="zl2List"
            :tableHeader="zl2Header"
            :labelName="labelName.b4"
            :editable="editable"
          ></HJTABLE>
        </el-col>
        <el-col :span="8">
          <HJTABLE
            :SClist="zl2List"
            :tableHeader="zl2Header"
            :labelName="labelName.b4"
            :editable="editable"
          ></HJTABLE>
        </el-col>
      </el-row>
    </div>
    <HJTABLE
      :SClist="clList"
      :tableHeader="clHeader"
      :labelName="labelName.b4"
      :editable="editable"
    ></HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { fanbianVoLast, save } from "@/api/FBapi";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
import { useRouter } from "vue-router";
import { headReport, getDate, getTime } from "@/api/head";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const router = useRouter();
    const clHeader = reactive([
      {
        prop: "shijian1",
        label: "时间",
        editable: false,
        type: "text",
      },
      {
        prop: "jitou",
        label: "机头",
        editable: false,
        type: "input",
      },
      {
        prop: "kuandu",
        label: "翻边宽度",
        editable: false,
        type: "input",
      },
      {
        prop: "fengkouGg",
        label: "封口后罐高",
        editable: false,
        type: "text",
      },
      {
        prop: "juanbianHd",
        label: "卷边厚度",
        editable: false,
        type: "input",
      },
      {
        prop: "juanbianKd",
        label: "卷边宽度",
        editable: false,
        type: "input",
      },

      {
        prop: "guangouCd",
        label: "罐钩长度",
        editable: false,
        type: "input",
      },
      {
        prop: "gaigouCd",
        label: "盖钩长度",
        editable: false,
        type: "input",
      },
      {
        prop: "jinmidu",
        label: "紧密度标准",
        editable: false,
        type: "text",
      },
    ]);
    const zlHeader = reactive([
      {
        prop: "jitouDate1",
        label: "时间",
        editable: false,
        type: "text",
      },
      {
        prop: "jitou",
        label: "滚筋机头",
        editable: false,
        type: "input",
      },
      {
        prop: "waiguan",
        label: "外观",
        editable: false,
        type: "input",
      },
    ]);
    const zl2Header = reactive([
      {
        prop: "jitouDate1",
        label: "时间",
        editable: false,
        type: "text",
      },
      {
        prop: "jitou",
        label: "封口机头",
        editable: false,
        type: "input",
      },
      {
        prop: "waiguan",
        label: "卷封外观质量",
        editable: false,
        type: "input",
      },
    ]);
    const ytfpHeader = reactive([
      {
        prop: "total",
        label: "印铁废品(总计)",
        editable: false,
        type: "text",
      },
      {
        prop: "chongyingNum",
        label: "重印",
        editable: false,
        type: "input",
      },
      {
        prop: "zazhidianNum",
        label: "杂质点",
        editable: false,
        type: "input",
      },
      {
        prop: "moranNum",
        label: "墨染",
        editable: false,
        type: "input",
      },
      {
        prop: "louyinNum",
        label: "漏印",
        editable: false,
        type: "input",
      },
      {
        prop: "sechaNum",
        label: "色差",
        editable: false,
        type: "input",
      },
      {
        prop: "neiyinseNum",
        label: "内印色",
        editable: false,
        type: "input",
      },

      {
        prop: "waituzouweiNum",
        label: "外涂走位",
        editable: false,
        type: "input",
      },

      {
        prop: "neiwaitucashangNum",
        label: "内外涂擦伤",
        editable: false,
        type: "input",
      },
      {
        prop: "namePihaoValue",
        label: "产品名称/批号",
        editable: false,
        type: "input",
      },
    ]);

    const fbfpHeader = reactive([
      {
        prop: "total",
        label: "生产废品(总计)",
        editable: false,
        type: "text",
      },
      {
        prop: "kaguanNum",
        label: "卡罐",
        editable: false,
        type: "input",
      },
      {
        prop: "yahenNum",
        label: "压痕",
        editable: false,
        type: "input",
      },
      {
        prop: "huashangNum",
        label: "划伤",
        editable: false,
        type: "input",
      },
      {
        prop: "youguanNum",
        label: "油罐",
        editable: false,
        type: "input",
      },
      {
        prop: "shuanggaiNum",
        label: "双盖",
        editable: false,
        type: "input",
      },
      {
        prop: "choujianNum",
        label: "抽检",
        editable: false,
        type: "input",
      },
      {
        prop: "guanjinblNum",
        label: "滚筋不良",
        editable: false,
        type: "input",
      },
      {
        prop: "fengkoublNum",
        label: "封口不良",
        editable: false,
        type: "input",
      },
      {
        prop: "namePihaoValue",
        label: "产品名称/批号",
        editable: false,
        type: "input",
      },
    ]);
    const tableHeader = reactive([
      {
        prop: "gaichang",
        label: "盖厂家",
        editable: false,
        type: "input",
      },
      {
        prop: "riqi",
        label: "日期",
        editable: false,
        type: "text",
      },
      {
        prop: "shengchanphBh",
        label: "生产批号-板号",
        editable: false,
        type: "input",
      },
      {
        prop: "shuliang",
        label: "数量(片/板)",
        editable: false,
        type: "text",
      },
      {
        prop: "shijishuliang",
        label: "实际使用数量",
        editable: false,
        type: "input",
      },
      {
        prop: "chashu",
        label: "差数",
        editable: false,
        type: "input",
      },
      ,
      {
        prop: "shiyong",
        label: "使用情况",
        editable: false,
        type: "input",
      },
    ]);
    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });
    let hanjiRdData = reactive({
      fanbianRdList: {},
      feipinYintie: {},
      feipinFanbian: {},
      fanbianZhiliangRdList: {},
      fanbianZhiliangRd2List: {},
      fanbianClList: {},
      fanbianClFw: {},
    });

    let labelName = {
      b1: "生产记录",
      b2: "废品统计",
      b3: "生产废品",
      b4: "质量记录",
    };
    let editable = ref(false);

    let SClist = ref([]);
    let hjData = ref({});

    let ytfpData = ref([]);
    let fbfpData = ref([]);

    let zlList = ref([]);
    let zl2List = ref([]);

    let clList = ref([]);
    let clfwData = ref([]);
    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    const getListData = async () => {
      const data = await fanbianVoLast();
      parse(data);
    };
    function parse(data) {
      headData.head = data.data.head;
      headData.head.reportTime1 = getDate(headData.head.reportTime);
      hanjiRdData.fanbianRdList = data.data.fanbianRdList;

      hjData.value = { ...headData.head, ...hanjiRdData.fanbianRdList };

      SClist.value = data.data.fanbianRdList;
      ytfpData.value = [data.data.feipinYintie];
      fbfpData.value = [data.data.feipinFanbian];

      zlList.value = data.data.fanbianZhiliangRdList;
      zl2List.value = data.data.fanbianZhiliangRd2List;

      clList.value = data.data.fanbianClList;
      clfwData.value = [data.data.fanbianClFw];
      console.log("clfwData.....", clfwData);

      zlList.value.filter((item) => {
        if (item != null) item.jitouDate1 = item.jitouDate.substr(11, 5);

        return item;
      });
      zlList.value.filter((item) => {
        if (item != null) {
          if (item.waiguan == 1) {
            item.good = "好";
          } else {
            item.bad = "坏";
          }
        }

        return item;
      });
      zl2List.value.filter((item) => {
        if (item != null) item.jitouDate1 = item.jitouDate.substr(11, 5);

        return item;
      });
      zl2List.value.filter((item) => {
        if (item != null) {
          if (item.waiguan == 1) {
            item.good = "好";
          } else {
            item.bad = "坏";
          }
        }

        return item;
      });
      clList.value.filter((item) => {
        if (item != null && item.shijian != null)
          item.shijian1 = item.shijian.substr(11, 5);

        return item;
      });
    }
    const saveData = async () => {
      editable = false;
      let data = {
        head: headData.head,
        fanbianRdList: SClist.value,
        feipinYintie: ytfpData.value[0],
        feipinFanbian: fbfpData.value[0],

        fanbianZhiliangRdList: zlList.value,
        fanbianZhiliangRd2List: zl2List.value,
        fanbianClList: clList.value,
        fanbianClFw: clfwData.value[0],
      };
      console.log("save data...", data);
      const dt = await save(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      } else {
        console.log("....error save", dt);
      }
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "翻边、滚筋/封口工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("fb.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象

        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,

          t1: SClist.value,
          t2: ytfpData.value,
          t3: fbfpData.value,
          t4: zlList.value,
          t5: zl2List.value,
          t6: clfwData.value[0],
          t7: clList.value,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "翻边、滚筋/封口工序生产质量记录.docx");
      });
    }
    const getRouterData = async (req) => {
      console.log("req....", req);
      const data = await headReport(req);
      console.log("jbj router data.....", data);

      parse(data);
    };
    onMounted(() => {
      console.log("rrrrrrrrrrr", router.currentRoute.value.query);
      let head_id = router.currentRoute.value.query.id;
      let leixing = router.currentRoute.value.query.leixing;
      console.log("vue recv....", head_id, leixing);
      if (head_id == null) {
        getListData();
      } else {
        getRouterData({ head_id: head_id, leixing: leixing });
      }
    });
    return {
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      tableHeader,
      ytfpHeader,
      fbfpHeader,
      zlHeader,
      zl2Header,
      clHeader,
      getListData,
      headData,
      toImage,
      imageWrapper,
      SClist,
      ytfpData,
      fbfpData,
      zlList,
      zl2List,
      clList,
      clfwData,
      exportWord,
      labelName,
      editable,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}
#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}
.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}
.title_form_input {
  font-size: 16px;
}
</style>
